//----------------------------------------------------------------------------
// Copyright (c) 2008-2015 Fabrice HARROUET (ENIB)
//
// This file is part of TransProg.
//
// TransProg is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// TransProg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

#ifndef TRANSPROG_PLUGIN_H
#define TRANSPROG_PLUGIN_H 1

#include "TransProg/platform.h"

typedef void *PluginHandle;

TRANSPROG_API
PluginHandle // plugin or 0
Plugin_open(const char *pluginName);

TRANSPROG_INLINE
PluginHandle // plugin or 0
Plugin_openCurrentBinary(void)
{
return Plugin_open((const char *)0);
}

TRANSPROG_API
void * // symbol or 0
Plugin_symbol(PluginHandle plugin,
              const char *symbolName);

#define Plugin_function(out_function,plugin,symbolName)                \
        do                                                             \
          {                                                            \
          *((void **)(out_function))=Plugin_symbol(plugin,symbolName); \
          } while(0)

TRANSPROG_API
void
Plugin_lastErrorMsg(char *out_msg,
                    int msgSize);

TRANSPROG_API
void
Plugin_close(PluginHandle plugin);

#endif // TRANSPROG_PLUGIN_H

//----------------------------------------------------------------------------
