#!/usr/bin/env python
# -*- coding: utf-8 -*-
#-----------------------------------------------------------------------------
# Copyright (C) 2008-2015 Fabrice HARROUET (ENIB)
#
# This file is part of TransProg.
# 
# TransProg is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# TransProg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public License
# along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
#-----------------------------------------------------------------------------

import sys ; sys.path.insert(0,'../../lib')
import TransProgConfig

import glob

#-------- Create the construction tool ---------------------------------------

tool=TransProgConfig.Tool()

tool.addCudaSettings()

tool.settings['DEFINES']['WIN32_TRANSCUDA_DLL']=None

topDir=tool.settings['TRANSPROG_DIR']

#-------- Enumerate targets and source files ---------------------------------

headers=[f for f in glob.glob(topDir+'/include/TransCuda/*.h')
         if not f.endswith('transCudaAsyncCalls.h')]

tool.Template(topDir+'/include/TransCuda/transCudaAsyncCalls.h',
              [topDir+'/lib/asyncCallGenerator.py']+headers,
              ['-h',topDir+'/include/TransProg/platform.h',
               '-h',topDir+'/include/TransCuda/api.h'])

tool.Library(topDir+'/lib/TransCuda',
             ['cuda.c'])

tool.Clean('swig_*')

tool.run()

#-----------------------------------------------------------------------------
