//----------------------------------------------------------------------------
// Copyright (c) 2008-2015 Fabrice HARROUET (ENIB)
//
// This file is part of TransProg.
//
// TransProg is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// TransProg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with TransProg.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

// included from glView_x11.c, glView_win32.c and glView_cocoa.m

static
const char *extSuffixes[]={ "", "ARB", "EXT", (const char *)0 };

static
GfxStereoMode
GlView_detectStereoMode(void)
{
const char *keywords[]={ "none", "active", "split" };
return (GfxStereoMode)Platform_environAsKeyword("TRANSGL_STEREO",
                                                keywords,3,0);
}

static
bool // success
GlView_detectGlVersion(int *out_major,
                       int *out_minor)
{
PFNGLGETSTRINGPROC getStringFnct=(PFNGLGETSTRINGPROC)0;
CoreGl_extensionFunction(&getStringFnct,"glGetString");
if(getStringFnct)
  {
  const char *version=(const char *)getStringFnct(GL_VERSION);
  if(version&&(sscanf(version,"%d.%d",out_major,out_minor)==2))
    {
    return true;
    }
  }
*out_major=0;
*out_minor=0;
return false;
}

//----------------------------------------------------------------------------
